// Craig S. Kaplan
//
// Compare this sketch to FakeNoise.  This one simply uses
// the built-in noise() function to draw a graph in a way
// that supports direct manipulation anywhere on the line.

// Amount of translation for direct manipulation purposes.
float dx;

void setup()
{
  size( 600, 200 );
  dx = 0;
}

float myFunc( float x )
{
  float v = noise( x );
  return map( v, 0, 1, 0, height );
}

void draw()
{
  background( 255 );
  strokeWeight( 2 );
  stroke( 255, 0, 0 );
  noFill();
  
  beginShape();
  for( int x = 0; x < 600; ++x ) {
    vertex( x, myFunc( x - dx ) );
  }
  endShape();
}

void mouseDragged()
{
  dx += mouseX - pmouseX;
}