// Craig S. Kaplan
//
// Visualize the 2D noise function as an image by 
// setting in individual pixels in the sketch window
// every frame.  Support direct manipulation.

// Translation amounts for direct manipulation.
float tx;
float ty;

// Scaling factor for the noise() function.  Try
// changing this number!
float sc = 100.0;

void setup()
{
  size( 300, 300 );
}

void draw()
{
  for ( int y = 0; y < width; ++y ) {
    for ( int x = 0; x < height; ++x ) {
      float v = noise( (x-tx) / sc, (y-ty) / sc );
      set( x, y, color( v * 256.0 ) );
    }
  }
}

void mouseDragged()
{
  tx += mouseX - pmouseX;
  ty += mouseY - pmouseY;
}